<?php

	$params;
	$programs;
	$programCounter = 0;
	$conflictCounter = 0;
	
	function conflict($a, $b, $c, $d){
		
		list($ASmonth, $ASday, $ASyear, $AShour, $ASminute) = sscanf($a,"%d/%d/%d %d:%d");
		list($AEmonth, $AEday, $AEyear, $AEhour, $AEminute) = sscanf($b,"%d/%d/%d %d:%d");
		list($BSmonth, $BSday, $BSyear, $BShour, $BSminute) = sscanf($c,"%d/%d/%d %d:%d");
		list($BEmonth, $BEday, $BEyear, $BEhour, $BEminute) = sscanf($d,"%d/%d/%d %d:%d");
		
		$AS = mktime($AShour, $ASminute, 0, $ASmonth, $ASday, $ASyear);
		$AE = mktime($AEhour, $AEminute, 0, $AEmonth, $AEday, $AEyear);
		$BS = mktime($BShour, $BSminute, 0, $BSmonth, $BSday, $BSyear);
		$BE = mktime($BEhour, $BEminute, 0, $BEmonth, $BEday, $BEyear);
		/*
		echo("<table border=1 cellpadding=0 cellspacing=0>");
		echo("<tr><td>$AS</td></tr>");
		echo("<tr><td>$AE</td></tr>");
		echo("<tr><td>$BS</td></tr>");
		echo("<tr><td>$BE</td></tr>");
		echo("</table>");
		*/
		if(($AS >= $BS) && ($AS < $BE)){
			
			return TRUE;
			
		}//if
		
		if(($AE > $BS) && ($AE <= $BE)){
			
			return TRUE;
			
		}//if
		
		if(($BS >= $AS) && ($BS < $AE)){
			
			return TRUE;
			
		}//if
		
		if(($BE > $AS) && ($BE <= $AE)){
			
			return TRUE;
			
		}//if
		
		return FALSE;
		
	}//conflict

	function startElement($parser, $name, $attrs) {
		
		global $programs;
		global $programCounter;
		
		if($name == "PROGRAM"){
			
			$programs[$programCounter] = $attrs;
			$programCounter++;
						
		}//if
		
	}//startElementProgram
	
	function endElement($parser, $name){
		

    	
	}//endElementProgram

/*** Main ***/
	
	if(!($fp = fopen("/BeOS2/home/BeVo/php/config.ini", "r"))){
		
		die("Could not open config file.");
		
	}//if
	
	while($data = fscanf($fp, "%s = %s\n")){
		
		list ($param, $val) = $data;
		
		$$param = $val;
				
	}//while
	
	if(!($fp = fopen($scheduleFile, "r"))){
		
		die("Could not open xml file.");
		
	}//if
	
	$xml_parser = xml_parser_create();
	xml_set_element_handler($xml_parser, "startElement", "endElement");
	if (!($fp = fopen($scheduleFile, "r"))) {
    	die("could not open XML input");
	}

	while ($data = fread($fp, 4096)) {
    	if (!xml_parse($xml_parser, $data, feof($fp))) {
        	die(sprintf("XML error: %s at line %d",
               	    xml_error_string(xml_get_error_code($xml_parser)),
                   	xml_get_current_line_number($xml_parser)));
	   	}
	}
	xml_parser_free($xml_parser);
	
	for($x = 0;$x < $programCounter;$x++){
		
		for($y = $x + 1;$y < $programCounter;$y++){
			
			if(conflict($programs[$x]["STARTTIME"], $programs[$x]["ENDTIME"], $programs[$y]["STARTTIME"], $programs[$y]["ENDTIME"])){
				
				if($printConflicts){
					
					echo("<p><a href='../remOneShot/remProg.php?ID=" . $programs[$x]["ID"] . "'>" . $programs[$x]["NAME"] . "</a> conflicts with <a href='../remOneShot/progInfo.php?ID=" . $programs[$y]["ID"] . "'>" . $programs[$y]["NAME"] . "</a></p>");
					
				}//if
				$conflictCounter++;
								
			}//if
						
		}//for
		
	}//for
	
?>
